jvx.volume

## Class PwStc

- java.lang.Object
- - jv.object.PsObject
  - - jvx.project.PjWorkshop
    - - jvx.volume.PwStc

- All Implemented Interfaces:
    java.io.Serializable, java.lang.Cloneable, PsUpdateIf, PjWorkshopIf

      public class PwStc
      extends PjWorkshop

  Workshop to compute the Spatial Twist Continuum of an all-hexahedral mesh.
  See Also:
    Serialized Form
  Author:
    Ulrich Reitebuch
  Version:
    09.03.15, 2.00 revised (kp) Moved to jvx.volume from dev.volume.
    04.10.10, 1.00 (ur) created

- - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `PgCubeSet` | `m_cubeSet` The geometry to work on.
    `PiVector` | `m_cubeToSurface` Map from cube index to surface index.
    `int` | `m_numSurfaces` The number of surfaces in the Spatial Twist Continuum.
    `PiVector[]` | `m_stc` Connectivity of Spatial Twist Continuum.
    `PiVector[]` | `m_stcElement` The elements of the Spatial Twist Continuum.
    `PgPolygonSet` | `m_stcReebGraph` Neighbourhood Graph in the Spatial Twist Continuum.

    - ### Fields inherited from class jv.object.PsObject

      `HAS_BOUNDARY_PANEL, HAS_CONFIG_PANEL, HAS_INFO_PANEL, HAS_LABEL_PANEL, HAS_MATERIAL_PANEL, HAS_TEXTURE_PANEL, HAS_VECTOR_PANEL, INSPECTOR_INFO, INSPECTOR_INFO_EXT, IS_DELETED, IS_FIXED, IS_FOCUSSED, IS_PICKED, IS_SELECTED, IS_USED, NUM_TAGS`

    - ### Fields inherited from interface jv.project.PjWorkshopIf

      `MODE_BUG, MODE_STANDARD, MODE_VALIDATE`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `PwStc()` Constructor

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `void` | `computeStcConnectivity()` Compute the spatial twist continuum connectivity.
    `void` | `computeStcElements()` Compute all elements in the spatial twist continuum.
    `void` | `computeStcNeighbourhood()` Compute neighbourhood graph for STC surfaces.
    `void` | `init()` Initialize and reset project, stops the running animation if any.
    `void` | `selectSurface(int index)` Select all cubes belonging to STC surface with given index.
    `void` | `setGeometry(PgGeometry geom)` Set the geometry to work on.
    `void` | `showReebGraph()`
    `boolean` | `update(java.lang.Object event)` React on update events.

    - ### Methods inherited from class jvx.project.PjWorkshop

      `cancel, close, getDisplay, getDisplays, getGeometry, getMode, getSavedGeometry, getViewer, isModal, isStandalone, ok, removeGeometry, reset, setDisplay, setDisplays, setModal, setMode, setStandalone, setViewer`

    - ### Methods inherited from class jv.object.PsObject

      `addInspector, addUpdateListener, assureInspector, clearTag, clone, clone, clone, copy, getFather, getInfoPanel, getInspector, getName, getNumObjects, getSymbol, hasInspector, hasTag, hasUpdateListener, instanceOf, instanceOf, newInspector, newInspector, removeInspector, removeInspector, removeUpdateListener, setName, setParent, setSymbol, setTag, toString, updatePanels`

    - ### Methods inherited from class java.lang.Object

      `equals, getClass, hashCode, notify, notifyAll, wait, wait, wait`

    - ### Methods inherited from interface jv.object.PsUpdateIf

      `getFather, getName, setParent`

- - ### Field Detail

    - #### m_cubeSet

          public PgCubeSet m_cubeSet

      The geometry to work on.

    - #### m_numSurfaces

          public int m_numSurfaces

      The number of surfaces in the Spatial Twist Continuum.

    - #### m_stc

          public PiVector[] m_stc

      Connectivity of Spatial Twist Continuum.

    - #### m_stcElement

          public PiVector[] m_stcElement

      The elements of the Spatial Twist Continuum.

    - #### m_cubeToSurface

          public PiVector m_cubeToSurface

      Map from cube index to surface index.

    - #### m_stcReebGraph

          public PgPolygonSet m_stcReebGraph

      Neighbourhood Graph in the Spatial Twist Continuum.

  - ### Constructor Detail

    - #### PwStc

          public PwStc()

      Constructor

  - ### Method Detail

    - #### init

          public void init()

      Description copied from class: `PjWorkshop`
      Initialize and reset project, stops the running animation if any. Does not reset any registered display nor geometry. They must be reset individually in each subclass.
      Overrides:
        `init` in class `PjWorkshop`

    - #### setGeometry

          public void setGeometry(PgGeometry geom)

      Set the geometry to work on.
      Specified by:
        `setGeometry` in interface `PjWorkshopIf`
      Overrides:
        `setGeometry` in class `PjWorkshop`
      Parameters:
        `geom` - the workshop modifies this geometry.

    - #### computeStcNeighbourhood

          public void computeStcNeighbourhood()

      Compute neighbourhood graph for STC surfaces.
      Author:
        Ulrich Reitebuch
      Version:
        11.10.10, 1.00 (ur) created

    - #### showReebGraph

          public void showReebGraph()

    - #### computeStcConnectivity

          public void computeStcConnectivity()

      Compute the spatial twist continuum connectivity.
      Author:
        Ulrich Reitebuch
      Version:
        05.10.10, 1.00 (ur) created

    - #### computeStcElements

          public void computeStcElements()

      Compute all elements in the spatial twist continuum. Elements reference vertices located at cube centers, each cube will have three indices for the three surfaces passing through.
      Author:
        Ulrich Reitebuch
      Version:
        04.10.10, 1.00 (ur) created

    - #### selectSurface

          public void selectSurface(int index)

      Select all cubes belonging to STC surface with given index.
      Author:
        Ulrich Reitebuch
      Version:
        05.10.10, 1.00 (ur) created

    - #### update

          public boolean update(java.lang.Object event)

      React on update events.
      Specified by:
        `update` in interface `PsUpdateIf`
      Overrides:
        `update` in class `PjWorkshop`
      Parameters:
        `event` - sender of this update.
      Returns:
        true if update was correctly handled by superclass.
      See Also:
        `PsObject.setParent(PsUpdateIf)`, `PsObject.getFather()`, `PsObject.addUpdateListener(PsUpdateIf)`

"

The software JavaView? is copyright protected. All Rights Reserved.
"